﻿#-*- coding:utf-8 -*
from speech import speak, speakSpelling
import controlTypes
from controlTypes import ROLE_TABLEROW, ROLE_TREEVIEWITEM
from scriptHandler import  getLastScriptRepeatCount
from NVDAObjects.IAccessible import IAccessible
from ui import message
from wx import CallLater
from api import copyToClip
from time import time
import addonHandler,  os, sys
_curAddon=addonHandler.getCodeAddon()
sharedPath=os.path.join(_curAddon.path,"AppModules", "shared")
sys.path.append(sharedPath)
import utils
import py3compatibility
from  py3compatibility import _unicode, u
del sys.path[-1]

if sys.version_info.major == 3 :
	__filter_class__=filter
	def filter (*args) :
		return  [item for item in __filter_class__(*args)]
		
class MessageListItemFields (IAccessible):
	fields ="threadCol,statusCol,attachmentCol,subjectCol,correspondentCol,dateCol,sizeCol,junkStatusCol,tagsCol,senderCol,recipientCol,receivedCol,priorityCol,flaggedCol,unreadButtonColHeader,accountCol,unreadCol,totalCol,locationCol,idCol".split (",")  
	champs =["Discussion","statut",u"Pièces jointes","Sujet","Correspondants","Date","Taille",u"Statut indésirable",u"Étiquettes",u"Expéditeur","Destinataire",u"Reçu",u"Priorité","Suivi","unreadButtonColHeader","Compte","Non lus","Total","Emplacement","idCol"]
	notField ="Aucun champ texte"
	lastScriptKeyName=""
	chrono = False
	def initOverlayClass (self): 
		k=("1","2","3","4","5","6","7","8","9","0")  #,")","=" pb si double frappe?
		for e in k:self.bindGesture (u"kb:"+_unicode (e),"readField")  		
	def getLabelMailAddress (self,s):
		t = self.appModule.regExp_mailAddress.sub (" ",s)
		return (s[:s.index ("@")] if  t.isspace ()else t).strip (u" '\"~#*&")

	def readField_default  (self, currentScriptKeyName, keyRepeat):
		index =int (currentScriptKeyName[-1])+(9 if  currentScriptKeyName[0].isalpha () else 0)
		if index > len (self.appModule.columnID) : return message (self.notField)
		o =self.getChild (index-1);name, columnText  =o.name, o.columnHeaderText
		if not keyRepeat : return speak ("{columnText}  {name}".format (columnText = columnText, name =name), symbolLevel =0)
		speak (u"{columnText} copié dans le presse papier".format (columnText =columnText), symbolLevel =0)
		copyToClip (u""+name)
	def clickCell (self,obj,field):
		description = obj.description
		if utils.getIA2Attribute (obj,"threadCol"):  description = u"Fil de discussion " +(u"Masquées",u"Affichées")[self.role == ROLE_TABLEROW]
		self.appModule.sort_modeChanged   =([description,field] if field else description )
		obj.doAction ()
		if field in ("threadCol","unreadButtonColHeader","junkStatusCol"): field =False
		#update 
		o=self
		while o and not "id" in o.IA2Attributes.keys ():o=o.container 
		self.appModule.buildColumnID (o)
	def script_readField(self,gesture):
		index, cols, i, options, currentScriptKeyName, lastScriptRepeatCount = int (gesture.mainKeyName)+len (gesture.modifierNames)*9, self.appModule.columnID,-1, self.appModule.options["messengerWindow"], gesture.displayName, getLastScriptRepeatCount ()
		if not self.appModule.date_firstMessage :self.appModule.date_firstMessage ="oui"
		if index ==0:index=10
		if index >len (cols):return  message (u"Pas de colonne de rang %s"%(index)) 
		if not cols[0] in self.fields : return self.readField_default (currentScriptKeyName, lastScriptRepeatCount ) 
		if not cols[1] in self.fields : return self.readField_default (currentScriptKeyName, lastScriptRepeatCount )
		if index <=0 or index >len (cols) :return  message ("aucun champ texte")
		e0=0
		for e in range (len (self.fields)):
			if self.fields[e] in cols :
				i+=1
				if i == index-1: e0=e ; break
		field= self.fields[e0]
		champ= self.champs[e0]
		indix =  cols.index (field)
		self.lastCellCalledAndTime =[indix,time (),field]
		o = self.getChild (indix)
		if not o :return message (u"Le champ %s n'est pas disponible "%champ)
		value, columnHeaderText, columnHeaderText_original, add_doublePoint  =o.name, o.columnHeaderText,o.columnHeaderText, " : "
		if value in self.appModule.columnID : value =""
		#if  field =="subjectCol": value = (value [1:-1] if value.startswith ("[") and value.endswith ("]") or value.startswith ("{") and value.endswith ("}") else value )
		if field in  "correspondentCol,recipientCol,subjectCol, senderCol" and options.as_bool ("listGroupName"):value =self.appModule.regExp_nameListGroup.sub (" ",value)

		if field in ("correspondentCol","senderCol","recipientCol")  and options.as_bool ("mailAddress") :  value =self.getLabelMailAddress (value)
		if field == "subjectCol" : 
			value =self.appModule.regExp_AnnotationResponse.sub (" ",value)
		if field in ("receivedCol","dateCol") : value = utils.formatDateTime(value)  # and options["dateExtended"]
		if field =="threadCol":
			value = _(u"Les fil de discussion sont {state}").format (state = (u"Affichée",u"Masquée")[self.role == ROLE_TABLEROW])
			columnHeaderText, add_doublePoint ="",""
		elif field =="junkStatusCol":value ={"0":"acceptable","100":u"indésirable"}.get (value, "acceptable");columnHeaderText="status "
		elif field == "statusCol" and value =="":
			value ="Non lu"
		elif field == "flaggedCol" and value :
			value ="oui"
		elif field =="unreadCol" :value =("non","oui")[bool (value)]
		elif field =="unreadButtonColHeader" : 
			value = "message "+{False : columnHeaderText}.get (bool (value),value)
			add_doublePoint, columnHeaderText=""," "
		elif  field  =="attachmentCol"  and value: 
				return self.attachments()
		elif value in ("priorityCol","subjectCol") :value =""
		if value :
			s =u"{columnHeaderText} {value}".format (columnHeaderText = columnHeaderText, value= value)
		else:
			s= u"Pas de {columnHeaderText}".format (columnHeaderText= columnHeaderText)
		o= self
		while o and not "id" in o.IA2Attributes.keys () :o=o.container
		o=o.firstChild.getChild (index)
		value =value.strip ()
		#action
		o =self
		while o and not utils.getIA2Attribute (o): o = o.container
		x=(e for e in o.firstChild.children)
		for o in x :
			if utils.getIA2Attribute (o,field) :break
		self.lastCellCalledAndTime.append (o)
		lastScriptRepeatCount = (lastScriptRepeatCount  if  lastScriptRepeatCount and self.lastScriptKeyName == currentScriptKeyName else 0)
		self.lastScriptKeyName = currentScriptKeyName
		if not lastScriptRepeatCount : return speak  ([s], symbolLevel =0)
		if  self.chrono :self.chrono.Stop ()
		self.chrono =CallLater (150,self.copyOrSpell, columnHeaderText_original,value, lastScriptRepeatCount )
	script_readField.__doc__ = u"Lire les entêtes des colonnes dans la fenêtre principale"
	
	def copyOrSpell (self,columnHeaderText_original , value, lastScriptRepeatCount ):
		if lastScriptRepeatCount ==1 :speakSpelling (value)
		else:
			if copyToClip  (_unicode (value)): 
				message (_(u"%s copié dans le presse papier ") %  columnHeaderText_original)
			else:
				message (_(u"le champ %s n'a pas pu être copié dans le presse papier ") % columnHeaderText_original)
	
	def getPropertyPage(self):
		fg = api.getForegroundObject()
		try:
			if utils.versionTB()> 70 : propertyPages = filter(lambda o: o.role == controlTypes.ROLE_PROPERTYPAGE, filter(lambda o: o.role == controlTypes.ROLE_GROUPING, fg.children)[1].children)
			else :propertyPages = filter(lambda o: o.role == controlTypes.ROLE_PROPERTYPAGE, filter(lambda o: o.role == controlTypes.ROLE_GROUPING, fg.children)[0].children)
			return propertyPages[0]
		except IndexError:  #Pas de grouping
			return fg
		
	def isDocument(self):
		doc = None
		for frame in filter(lambda o: o.role == controlTypes.ROLE_INTERNALFRAME, self.getPropertyPage().children):
			try:
				doc = filter(lambda o: o.role == controlTypes.ROLE_DOCUMENT, frame.children)[0]
			except IndexError:
				pass
		return doc	
	def attachments (self):
		doc = self.isDocument()
		if doc and controlTypes.STATE_READONLY in doc.states:
			try:
				attachmentToggleButton = filter(lambda o: "id" in  o.IA2Attributes and o.IA2Attributes["id"] == "attachmentToggle", self.getPropertyPage().children)[0]
			except IndexError:
				message(u"Pas de pièce jointe")
				return
			if u"1 pièce" in attachmentToggleButton.next.name : 
				message (u"une pièce jointe")
			else : message(attachmentToggleButton.next.name)
			return attachmentToggleButton.next

