# -*- coding: iso-8859-15 -*-	
#A part of NonVisual Desktop Access (NVDA)
#13_09_2020
import winUser
from winUser import *
import api
import speech
from ui import message
from keyboardHandler import KeyboardInputGesture
from time import sleep
import wx
import addonHandler,  os, sys
_curAddon=addonHandler.getCodeAddon()
sharedPath=os.path.join(_curAddon.path,"AppModules", "shared")
sys.path.append(sharedPath)
import utils
import core
from tones import beep
import controlTypes
from speech import speakSpelling 
import scriptHandler
import globalCommands

def PutWindowOnForeground(hwnd, sleepNb, sleepTime):
	try:
		setForegroundWindow(hwnd)
	except:
		pass
	for i in [sleepTime]*(sleepNb-1):
		sleep(i)
		if winUser.getForegroundWindow() == hwnd:
			return True 
	KeyboardInputGesture.fromName("alt+Tab").send()
	sleep(sleepTime)
	if winUser.getForegroundWindow() == hwnd:
		return true
	return False
	
def SendKey(	keys) :
	KeyboardInputGesture.fromName(keys).send()	
	
class ListeDossiersMessages(wx.Dialog):
	_timer=None
	global avecNonLus, avecFiltre, index0 , oDeb, withUnread
	avecFiltre=False  
	filtre0=""
	filtre1=""
	
	def __init__(self, parent,ID, title, closeIfInactive): 
		super(ListeDossiersMessages, self).__init__(parent, ID,title) 
		self.closeIfInactive = closeIfInactive
		self.destroyed = False
		##self.lbDossiers=[obj[0] for obj in self.getlisteDossiers(False)] # pb avec expression recherche
		# self.objectTypeHasChanged = True
		self.doGui()
	def doGui(self):		
		panel = self
		panelSizer = wx.GridBagSizer (6,4)
		self.taggedObjectsCB = wx.CheckBox(panel, wx.ID_ANY, label =u"Afficher seulement les dossiers avec &non lus")
		self.taggedObjectsCB.SetValue(avecNonLus)   #<<<< False  True
		panelSizer.Add(self.taggedObjectsCB, pos=(0,0), span= (1,1), flag=wx.EXPAND|wx.LEFT|wx.TOP,border=10)
		self.rechercheLabel=wx.StaticText(panel, wx.ID_ANY, label=u"Expression de &filtrage : " )
		panelSizer.Add(self.rechercheLabel,pos=(0,1), span= (1,1), flag=wx.EXPAND|wx.LEFT|wx.TOP,border=15)
		self.zoneRecherche = wx.TextCtrl(panel, wx.ID_ANY)
		self.zoneRecherche.Value ="" 
		panelSizer.Add(self.zoneRecherche, pos=(0,2), span= (1,1), flag=wx.EXPAND|wx.TOP,border=10)
		self.typeLabel = wx.StaticText(panel, wx.ID_ANY, label="&Comptes de messagerie: " )
		panelSizer.Add(self.typeLabel, pos=(1,0), span= (1,1), flag=wx.EXPAND|wx.LEFT,border=15)
		#the list boxes
		self.lbComptes = wx.ListBox(panel, wx.ID_ANY, style = wx.LB_SINGLE, size = (260, 400))
		if len(self.getlisteComptes())>0:   
			self.lbComptes.SetItems([obj[0] for obj in self.getlisteComptes()])  
			self.lbComptes.Select(0) 
		panelSizer.Add(self.lbComptes, pos=(2,0), span= (5,1), flag=wx.EXPAND|wx.LEFT|wx.BOTTOM, border=10)	
		self.elemLabel = wx.StaticText(panel, wx.ID_ANY, label=u"Do&ssiers des comptes: " )
		panelSizer.Add(self.elemLabel, pos=(1,1), span= (1,1), flag=wx.EXPAND|wx.LEFT,border=15)
		self.lbDossiers = wx.ListBox(panel, wx.ID_ANY,  style = wx.LB_SINGLE, size = (400, 400))
		if len(self.getlisteDossiers())>0:   
			self.lbDossiers.SetItems([obj[0] for obj in self.getlisteDossiers()])
			self.lbDossiers.Select(0) 
		panelSizer.Add(self.lbDossiers, pos=(2,1), span=(5,2), flag=wx.EXPAND|wx.LEFT|wx.BOTTOM,
			border=10)
		# the buttons
		self.rightClickButton=wx.Button(panel, wx.NewId(), label =("Simple clic &droit"), size = (120, 30)) 
		self.leftClickButton=wx.Button(panel, wx.NewId(), label =("Simple clic &gauche"), size = (120, 30))
		self.infosButton=wx.Button(panel, wx.NewId(), label =("Informations"), size = (120, 30))
		self.leftClickButton.SetDefault()
		self.cancelButton =wx.Button(panel,wx.ID_CANCEL, size = (120, 30))
		panelSizer.Add(self.rightClickButton,(2,3),flag=wx.ALL, border = 10)
		panelSizer.Add(self.leftClickButton,(3,3),flag=wx.ALL, border = 10)  
		panelSizer.Add(self.infosButton,(4,3),flag=wx.ALL, border = 10)  
		panelSizer.Add(self.cancelButton,(6,3),flag = wx.ALL, border= 10)
		panel.SetSizerAndFit(panelSizer)
		# the events 
		self.taggedObjectsCB.Bind(wx.EVT_CHECKBOX,self.onCaseChange)  
		self.zoneRecherche.Bind(wx.EVT_KEY_DOWN, self.onKeydown0)
		self.lbComptes.Bind(wx.EVT_SET_FOCUS,self.onObjectTypeListBoxFocus)  
		self.lbComptes.Bind(wx.EVT_LISTBOX,self.onElementComptesChange)  
		self.lbComptes.Bind(wx.EVT_KEY_DOWN, self.onKeydown1)	
		self.lbDossiers.Bind(wx.EVT_KEY_DOWN, self.onKeydown2)
		
		self.leftClickButton.Bind(wx.EVT_BUTTON, self.onLeftMouseButton) 
		self.leftClickButton.Bind(wx.EVT_KEY_DOWN, self.onKeydownButton)  
		self.rightClickButton.Bind(wx.EVT_BUTTON, self.onRightMouseButton)	
		self.rightClickButton.Bind(wx.EVT_KEY_DOWN, self.onKeydownButton) 	
		self.infosButton.Bind(wx.EVT_BUTTON, self.onKeydownButton0) 		
		self.infosButton.Bind(wx.EVT_KEY_DOWN ,self.onKeydownButton)
		self.cancelButton.Bind(wx.EVT_BUTTON,self.onCancelButton)
		self.cancelButton.Bind(wx.EVT_KEY_DOWN, self.onKeydownButton)
		self.Bind(wx.EVT_ACTIVATE, self.onActivate)
		self.Bind(wx.EVT_CLOSE, self.onClose)
		self.lbDossiers.SetFocus()
		self.sayNumberOfElements()
		
	def sayNumberOfElements(self):
		def callback (count):
			self._timer=None
			if count:
				msg = (u"%s lments") %str(count) if count > 1 else (u"Un lment")
				message(msg)
			else:
				message(u"aucun lment")
		if self._timer is not None:
			self._timer.Stop()
		self._timer = wx.CallLater(200,callback, self.lbDossiers.Count) 
		
	def getPositionXY (self):
		if self.lbComptes.HasFocus(): 
			beep (440,75)
			return
		itemSelected=self.lbDossiers.GetSelection() 
		locat=self.getlisteDossiers()[itemSelected][1]
		visible=self.getlisteDossiers()[itemSelected][2]
		if visible ==False : 
			message (u"Dossier non affich  l'cran")
			return False
		xyItem=(int(locat[0])+int(locat[2]/2),int(locat[1])+int(locat[3]/2))
		return xyItem 

	def onClose(self, evt):
		self.Destroy()
		self.destroyed = True  
		evt.Skip()
		
	def onCaseChange(self, evt): 
		if self.taggedObjectsCB.GetValue()  : message ("Avec non lus")
		else :message ("Tous les dossiers")
		self.lbDossiers.Clear()
		self.lbDossiers.SetFocus() 
		if len(self.getlisteDossiers())==0: 
			return message (u"Aucun rsultat")
		self.lbDossiers.SetItems([obj[0] for obj in self.getlisteDossiers() ]) 
		self.sayNumberOfElements()
		self.lbDossiers.Select(0) 
		# self.changeSelectionComptes()
		# self.objectTypeHasChanged = True
		return
		evt.Skip()  
		
	def onObjectTypeListBoxFocus(self,evt):
		self.sayNumberOfElements()
			
	def onElementComptesChange(self, evt): 
		self.lbDossiers.Clear()
		self.lbDossiers.SetItems([obj[0] for obj in self.getlisteDossiers() ]	)	
		self.sayNumberOfElements()
		# self.objectTypeHasChanged = True
		
	def changeSelectionComptes(self): 
		index0=self.lbDossiers.GetSelection()
		obj=self.getlisteDossiers()[index0][0].split("dans ")[-1]
		if obj[:1]==" " : obj=obj[1:]
		self.lbComptes.Select(self.getlisteComptes().index(obj)) 

	def onKeydownButton0(self, evt):
		if self.taggedObjectsCB.GetValue() : message ("Affichage des dossiers non lus ") 
		else :message ("Affichage de tous les dossiers ") 
		st= self.zoneRecherche.GetValue()
		if st=="" : message ("pas d'expression de filtrage ")
		else :
			message (u"expression de filtrage : %s "%st) 	
			if len(st)>1 :speakSpelling (st) 
		wx.CallAfter(self.sayNumberOfElements)
		return
		evt.Skip()	
		
	def onKeydownButton(self, evt):
		# keyCode= evt.GetKeyCode()
		keyCode= evt.KeyCode
		if keyCode ==wx.WXK_BACK:   
			core.callLater(200,SendKey ,"Alt+s")			
			return 	
		if keyCode ==wx.WXK_LEFT:   
			core.callLater(200,SendKey ,"Shift+Tab")			
			return 	
		if keyCode == wx.WXK_ESCAPE:
			self.Close()
			return
		evt.Skip()
		
	def onKeydown1(self, evt): 
		keyCode= evt.KeyCode
		if  keyCode ==wx.WXK_RIGHT :
			if  self.lbComptes.HasFocus(): 
				index0=self.lbDossiers.GetSelection()
				if index0 >0 :
					oldSpeechMode = speech.speechMode
					speech.speechMode =speech. speechMode_off
					speech.cancelSpeech()
					sleep(0.2)
					self.lbDossiers.Select(index0) 
					self.lbDossiers.SetFocus() 
					api.processPendingEvents()
					sleep(0.2)
					speech.speechMode=oldSpeechMode				
					self.lbDossiers.Select(index0) 
				else :
					if len(self.getlisteDossiers()) : self.lbDossiers.Select(0) 
					self.lbDossiers.SetFocus() 
				return 
		if keyCode ==wx.WXK_LEFT:   
			core.callLater(200,SendKey ,"Shift+Tab")				
			return 		
		if keyCode ==wx.WXK_F12:   
			core.callLater(200,SendKey ,"Alt+n")	
			return 			
		if keyCode in [wx.WXK_F11,wx.WXK_PAGEUP,wx.WXK_PAGEDOWN]:  
			core.callLater(200,SendKey ,"Alt+f")	
			return 		
		evt.Skip()
	
	def onKeydown0(self, evt): 
		keyCode= evt.KeyCode
		if  keyCode ==wx.WXK_UP: 
			if  self.zoneRecherche.HasFocus() :
				core.callLater(200,SendKey ,"Shift+Tab")
				return	
		if keyCode ==wx.WXK_DOWN:  
			if  self.zoneRecherche.HasFocus() :
				core.callLater(200,SendKey ,"Tab")
				return 
		if keyCode ==wx.WXK_F12:   
			if  self.zoneRecherche.HasFocus() :
				core.callLater(200,SendKey ,"Alt+n")	
				return 		 
		if keyCode in [wx.WXK_F11,wx.WXK_PAGEUP,wx.WXK_PAGEDOWN]: 
			if  self.zoneRecherche.HasFocus() :
				filtre = self.zoneRecherche.GetValue()
				if filtre =="" : 
					if keyCode ==wx.WXK_F11 : beep (330, 75) 
					else : message (u"Pas d'expression entre")
					self.lbDossiers.Clear()
					self.lbDossiers.SetItems([obj[0] for obj in self.getlisteDossiers() ]) 
					self.lbDossiers.Select(0)
					self.lbDossiers.SetFocus() 
					return 
				if len(self.getlisteDossiers())==0: 
					if keyCode ==wx.WXK_F11 :beep (440, 75)
					else : message (u"Aucun rsultat")
					# self.lbDossiers.SetFocus() 
					return	
				message (filtre)
				self.lbDossiers.Clear()
				self.lbDossiers.SetItems([obj[0] for obj in self.getlisteDossiers() ]) 
				self.lbDossiers.Select(0)	
				self.lbDossiers.SetFocus() 	
				self.sayNumberOfElements()
				# self.changeSelectionComptes()
				return 					
		evt.Skip()	

	def onKeydown2(self, evt): 
		keyCode=evt.KeyCode
		if keyCode in [68,71]  : 	# alt+d	alt+g
			clic =("Simple clic droit"  if keyCode == 68 else "Simple clic gauche" )
			o=api.getFocusObject()
			while o and not o.role==1 : o=o.parent
			while o and not o.name==clic :o=o.next 
			if o.firstChild : o=o.firstChild
			api.setNavigatorObject(o)
			sleep(0.4)
			o.doAction()
			# scriptHandler.executeScript(globalCommands.commands.script_review_activate,None )  #None "space"
			# o.doAction()  "kb(desktop):NVDA+numpadEnter"
			core.callLater(200,SendKey ,"NVDA+numpadEnter") 
			return
			
		if keyCode ==wx.WXK_BACK : 
			o=api.getFocusObject()
			while o and not o.role==1 : o=o.parent
			while o and not o.name=="Informations" :o=o.next 
			if o.firstChild : o=o.firstChild
			api.setNavigatorObject(o)
			sleep(0.2)
			o.doAction()
			core.callLater(200,SendKey ,"NVDA+numpadEnter") 
			return						
		if  keyCode ==wx.WXK_RIGHT :
			if  self.lbDossiers.HasFocus(): #self.lbComptes.HasFocus() or }
				core.callLater(200,SendKey ,"Tab")
				return		
		if keyCode ==wx.WXK_LEFT:   
			core.callLater(200,SendKey ,"Shift+Tab")
			return 
		if keyCode ==wx.WXK_F12:   
			core.callLater(200,SendKey ,"Alt+n")	
			return 			
		if keyCode in [wx.WXK_F11,wx.WXK_PAGEUP,wx.WXK_PAGEDOWN]: 
			core.callLater(200,SendKey ,"Alt+f")	
			return 			
		evt.Skip()
		
	def onCancelButton(self, evt):
		self.Close()
		evt.Skip()
		
	def onActivate(self, evt):
		if not self.destroyed and self.closeIfInactive and not evt.GetActive():  
			self.Close()
		evt.Skip()
	
	def onLeftMouseButton(self,event):
		if not self.getPositionXY() : return
		(x,y)=self.getPositionXY()
		self.Close()
		winUser.setCursorPos(x,y)
		mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,None,None)
		sleep(0.1)
		mouse_event(MOUSEEVENTF_LEFTUP,0,0,None,None)
	
	def onRightMouseButton(self,event):
		if not self.getPositionXY() : return 
		(x,y)=self.getPositionXY()
		self.Close()
		winUser.setCursorPos(x,y)
		mouse_event(MOUSEEVENTF_RIGHTDOWN,0,0,None,None)
		sleep(0.1)
		mouse_event(MOUSEEVENTF_RIGHTUP,0,0,None,None)		
		
	def getlisteComptes(self):
		global oDeb
		avecNonLus = self.taggedObjectsCB.GetValue()  
		locat=None 
		visible=False
		name=""
		l=[] 
		o=oDeb
		max=o.childCount
		l.append(("Tous les comptes",o.children[1].location,False))   
		for i in range (1,max) :
			o1=o.children[i]
			if  utils.getIA2Attribute (o1,attribute_value=False,attribute_name ="level") =="1" : 
				name =o1.name
				locat = o1.location
				visible=(o1 and not controlTypes.STATE_INVISIBLE  in o1.states)  			
				l.append((name,locat,visible)) 		
		return l 
		
	def getlisteDossiers(self):
		global oDeb 
		filtre1=self.filtre0
		avecNonLus = self.taggedObjectsCB.GetValue()  
		try: 
			filtre1=self.filtre0=self.zoneRecherche.GetValue().lower()
		except :	
			filtre1=False
		locat=None 
		name=""
		lev=0
		idx= 0 
		l0=[] 
		l0.append((0,0))
		o=oDeb
		max=o.childCount
		for i in range (1,max) :
			o1=o.children[i]
			if  utils.getIA2Attribute (o1,attribute_value=False,attribute_name ="level") =="1" :  
				lev=1 ;idx+=1
				locat = o1.location
				l0.append((idx,i))
		indx=(self.lbComptes.GetSelection()  if self.lbComptes.GetSelection() else 0)
		n1=(1 if (avecNonLus or filtre1 or indx==0) else l0[indx][1]) 
		try :
			n2=(max  if (avecNonLus or filtre1 or indx==0)  else l0[indx+1][1])
		except : n2=max  
		l=[] 
		o=oDeb
		o2=o.children[1]
		for i in range (n1,n2) :
			o1=o.children[i]
			name= o1.name
			if (utils.getIA2Attribute (o1,attribute_value=False,attribute_name ="level") =="1" ) :
				name=o1.name+ ", compte de messagerie"
				o2=o1
			if (avecNonLus and not "(" in o1.name ) or (filtre1 and  not filtre1 in o1.name.lower()) : continue
			if  (utils.getIA2Attribute (o1,attribute_value=False,attribute_name ="level") !="1") and (indx==0    or (avecNonLus and "(" in o1.name ) or (filtre1 and  filtre1 in o1.name.lower())) :	
				if o2:
					name =o1.name+ ", dans  "+o2.name
			locat = o1.location
			visible=(o1 and not controlTypes.STATE_INVISIBLE  in o1.states) 
			# "- ("  permet d'exclure les dossiers dont le nom se termine par un tiret (dossiers oubliettes)
			if "Corbeille" not in o1.name and "Brouillons" not in o1.name and "- (" not in o1.name :
				l.append((name,locat,visible)) 
		return l
		
	def run(cls,withUnread): 
		global oDeb ,avecNonLus  #  oDeb est l'arborescence des dossiers
		avecNonLus=withUnread
		o = api.getForegroundObject ().simpleFirstChild
		while o and o.role!=56 : o=o.next  
		o = o.firstChild.firstChild  
		while o and o.role!=20 : o=o.next 
		oDeb=o
		bdd = cls(None,wx.ID_ANY,(u"Dossiers de l'arborescence "), True) 
		bdd.CenterOnScreen()
		bdd.Show(True)
		PutWindowOnForeground(bdd.GetHandle(), 4, 0.1) 
	run = classmethod(run)
			
